// module appSingleton.cpp
// Garantees that a single instance ("application singleton") runs as a 
// process under Linux, 
// Private Coypright Dr. E.Huckert 03-2009

// Compile under Linux: 
//   g++ appSingleton.cpp mutex.cpp -lpthread
// Not tested under Windows!

#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "mutex.h"

using namespace  std;

int main(int argc, char *argv[])
{
  // Try to acquire an exclusive  lock on the given file 
  // File must be opened for writing!!!
  int fd = open("/tmp/singleton_lock", 1); 
  if (fd < 0)
  {
    fd = creat("/tmp/singleton_lock", 0666);
    if (fd >= 0)
    {
      close(fd);
      fd = open("/tmp/singleton_lock", 1); 
    }
  }
  if (fd < 0)
  {
    cout << "ERROR: cannot open/create lock file on /tmp" << endl;
    exit(1);
  }
  cout << "Lock file /tmp/singleton_lock is open" << endl;
  int n, ret;
  FILE_Mutex *pfm = new FILE_Mutex(fd);
  ret = pfm->setlock();  
  cout << "result setlock()=" << ret << endl;
  if (ret < 0)
  {
    cout << "ERROR: cannot acquire the lock" << endl;
    exit(2);
  }  
  //
  // Wait in a loop: a second process (same application) 
  // tries to get a lock on the same file
  for (n=0; n < 50; n++)
  {
    sleep(1);
    cout << "process " << getpid() << " waits " << n << " secs" << endl;
  }
  ret = pfm->unlock();
  delete pfm;
  close(fd);
  cout << "prozess " << getpid() << " terminates" << endl;
}   // end  main()

